org.apache.lucene.search.spans

## Class SpanNearQuery

- java.lang.Object
- - org.apache.lucene.search.Query
  - - org.apache.lucene.search.spans.SpanQuery
    - - org.apache.lucene.search.spans.SpanNearQuery

All Implemented Interfaces:
  Cloneable

    public class SpanNearQuery
    extends SpanQuery
    implements Cloneable

Matches spans which are near one another. One can specify slop, the maximum number of intervening unmatched positions, as well as whether matches are required to be in-order.

### Nested Class Summary

Nested Classes
`static class` `SpanNearQuery.Builder` A builder for SpanNearQueries
`class` `SpanNearQuery.SpanNearWeight`

### Field Summary

Fields
`protected List<SpanQuery>` `clauses`
`protected String` `field`
`protected boolean` `inOrder`
`protected int` `slop`

### Constructor Summary

Constructors
Constructor and Description
`SpanNearQuery(SpanQuery[] clausesIn, int slop, boolean inOrder)` Construct a SpanNearQuery.

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`SpanWeight` `createWeight(IndexSearcher searcher, ScoreMode scoreMode, float boost)` Expert: Constructs an appropriate Weight implementation for this query.
`boolean` `equals(Object other)` Override and implement query instance equivalence properly in a subclass.
`SpanQuery[]` `getClauses()` Return the clauses whose spans are matched.
`String` `getField()` Returns the name of the field matched by this query.
`int` `getSlop()` Return the maximum number of intervening unmatched positions permitted.
`int` `hashCode()` Override and implement query hash code properly in a subclass.
`boolean` `isInOrder()` Return true if matches are required to be in-order.
`static SpanNearQuery.Builder` `newOrderedNearQuery(String field)` Returns a `SpanNearQuery.Builder` for an ordered query on a particular field
`static SpanNearQuery.Builder` `newUnorderedNearQuery(String field)` Returns a `SpanNearQuery.Builder` for an unordered query on a particular field
`Query` `rewrite(IndexReader reader)` Expert: called to re-write queries into primitive queries.
`String` `toString(String field)` Prints a query to a string, with `field` assumed to be the default field and omitted.
`void` `visit(QueryVisitor visitor)` Recurse through the query tree, visiting any child queries

### Methods inherited from class org.apache.lucene.search.spans.SpanQuery

`getTermStates, getTermStates`

### Methods inherited from class org.apache.lucene.search.Query

`classHash, sameClassAs, toString`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Field Detail

#### clauses

    protected List<SpanQuery> clauses

#### slop

    protected int slop

#### inOrder

    protected boolean inOrder

#### field

    protected String field

### Constructor Detail

#### SpanNearQuery

    public SpanNearQuery(SpanQuery[] clausesIn,
                         int slop,
                         boolean inOrder)

Construct a SpanNearQuery. Matches spans matching a span from each clause, with up to `slop` total unmatched positions between them.
When `inOrder` is true, the spans from each clause must be in the same order as in `clauses` and must be non-overlapping.
When `inOrder` is false, the spans from each clause need not be ordered and may overlap.

Parameters:
  `clausesIn` - the clauses to find near each other, in the same field, at least 2.
  `slop` - The slop value
  `inOrder` - true if order is important

### Method Detail

#### newOrderedNearQuery

    public static SpanNearQuery.Builder newOrderedNearQuery(String field)

Returns a `SpanNearQuery.Builder` for an ordered query on a particular field

#### newUnorderedNearQuery

    public static SpanNearQuery.Builder newUnorderedNearQuery(String field)

Returns a `SpanNearQuery.Builder` for an unordered query on a particular field

#### getClauses

    public SpanQuery[] getClauses()

Return the clauses whose spans are matched.

#### getSlop

    public int getSlop()

Return the maximum number of intervening unmatched positions permitted.

#### isInOrder

    public boolean isInOrder()

Return true if matches are required to be in-order.

#### getField

    public String getField()

Description copied from class: `SpanQuery`
Returns the name of the field matched by this query.

Specified by:
  `getField` in class `SpanQuery`

#### toString

    public String toString(String field)

Description copied from class: `Query`
Prints a query to a string, with `field` assumed to be the default field and omitted.

Specified by:
  `toString` in class `Query`

#### createWeight

    public SpanWeight createWeight(IndexSearcher searcher,
                                   ScoreMode scoreMode,
                                   float boost)
                            throws IOException

Description copied from class: `Query`
Expert: Constructs an appropriate Weight implementation for this query.

Only implemented by primitive queries, which re-write to themselves.

Specified by:
  `createWeight` in class `SpanQuery`
  `scoreMode` - How the produced scorers will be consumed.
  `boost` - The boost that is propagated by the parent queries.
Throws:
  `IOException`

#### rewrite

    public Query rewrite(IndexReader reader)
                  throws IOException

Description copied from class: `Query`
Expert: called to re-write queries into primitive queries. For example, a PrefixQuery will be rewritten into a BooleanQuery that consists of TermQuerys.

Overrides:
  `rewrite` in class `Query`
Throws:
  `IOException`

#### visit

    public void visit(QueryVisitor visitor)

Description copied from class: `Query`
Recurse through the query tree, visiting any child queries

Overrides:
  `visit` in class `Query`
Parameters:
  `visitor` - a QueryVisitor to be called by each query in the tree

#### equals

    public boolean equals(Object other)

Description copied from class: `Query`
Override and implement query instance equivalence properly in a subclass. This is required so that `QueryCache` works properly. Typically a query will be equal to another only if it's an instance of the same class and its document-filtering properties are identical that other instance. Utility methods are provided for certain repetitive code.

Specified by:
  `equals` in class `Query`
See Also:
  `Query.sameClassAs(Object)`, `Query.classHash()`

#### hashCode

    public int hashCode()

Description copied from class: `Query`
Override and implement query hash code properly in a subclass. This is required so that `QueryCache` works properly.

Specified by:
  `hashCode` in class `Query`
See Also:
  `Query.equals(Object)`